unit code39;

interface

type
    TBarcodeData = array of Byte;

function ReadCode39(const Data: array of Byte; var Text: string; var Err: string): Boolean;

implementation

function ReadCode39(const Data: array of Byte; var Text: string; var Err: string): Boolean;
var
    First1Pos, Last1Pos: integer;
    Buf, SumBuf: TBarcodeData;
    i, Temp, SumBufLen, CharLen: integer;
    Prev, Curr, Counter: integer;
    WideVal, NaroVal: integer;
    CharBuf: array of integer;
begin
    Result := False;

    //-------------------------------------------
    //  o[R[h摜̃sNZǂݎf[^f[^ƌĂ
    //-------------------------------------------

    //-------------------------------------------
    //  STEP1

    //-------------------------------------------
    //  f[^ʒu
    First1Pos := 0;

    //  1oʒu
    while (First1Pos < Length(Data)) and (Data[First1Pos] = 0) do Inc(First1Pos);

    //  ŌɓBĂI
    if (First1Pos >= Length(Data)) then
    begin
        Err := 'o[R[hf[^ł͂܂B';
        Exit;
    end;

    //-------------------------------------------
    //  f[^ʒu
    Last1Pos := Length(Data) - 1;

    //  X1oʒu
    while (0 <= Last1Pos) and (Data[Last1Pos] = 0) do Dec(Last1Pos);

    //  ܂łĂƂƂ͈1̂őv

    //-------------------------------------------
    //  1oO0ƃX1o0̂ĂăRs[
    SetLength(Buf, Last1Pos - First1Pos + 1);
    Move(Data[First1Pos], Buf[0], SizeOf(Byte) * Length(Buf));

    //-------------------------------------------
    //  STEP2

    //-------------------------------------------
    //  Œ׎n߂
    Prev := Buf[0]; 
    Counter := 1;
    SumBufLen := 0;
    for i := 1 to Length(Buf) - 1 do
    begin
        //  ̒l
        Curr := Buf[i];

        //  O̒lƓ
        if (Prev = Curr) then
        begin
            Inc(Counter);
        end
        //  قȂ
        else
        begin
            //  ʂ̔zɓ˂
            Inc(SumBufLen);
            SetLength(SumBuf, SumBufLen);
            SumBuf[SumBufLen - 1] := Counter;

            //  JE^NA
            Counter := 1;
        end;

        //  O̒lXV
        Prev := Curr;        
    end;

    //  Ōɂx
    Inc(SumBufLen);
    SetLength(SumBuf, SumBufLen);
    SumBuf[SumBufLen - 1] := Counter;

    //-------------------------------------------
    //  STEP3

    //  TCY`FbN(1ł 9+1+[9]+1+9)
    if ((SumBufLen + 1) mod 10 <> 0) then
    begin
        Err := 'CODE39ł͂ȂłBo[ƃXy[XƃMbv̐܂B';
        Exit;
    end;

    //  𐔂
    CharLen := (SumBufLen + 1) div 10;

    //  ͂Ȃ
    if (CharLen < 3) then
    begin
        Err := 'CODE39ł͂ȂłBȂƂ3ȏɂȂ͂łB';
        Exit;
    end;

    //-------------------------------------------
    //  STEP4

    //  ̑/1/0ɒuBzƂẮASumBuf[0]lASumBuf[1]
    //  傫lŁA2ނ̐gpĂȂƊAȂ
    //  ȂB͏2{3{x̂͂B
    NaroVal := SumBuf[0];
    WideVal := SumBuf[1];

    //  TCY`FbN
    if (WideVal * 10 < NaroVal * 2 * {10}8) then
    begin
        Err := 'אɔׂď[ȑ܂B';
        Exit;
    end
    else if (WideVal * {10}8 > NaroVal * 3 * 10) then
    begin
        Err := 'אɔׂđ悤łB';
        Exit;
    end;

    for i := 0 to SumBufLen - 1 do
    begin
        //  LN^ԃMbv͖
        if ((i + 1) mod 10 = 0) then continue;

        //  lƂ̍אȉ
        if (Abs(WideVal - SumBuf[i]) * 2 < NaroVal) then
        begin
            //  Ȃ͑łB
            SumBuf[i] := 1;
        end
        //  lƂ̍
        else if (Abs(NaroVal - SumBuf[i]) * 2 < NaroVal) then
        begin
            //  Ȃ͍אłB
            SumBuf[i] := 0;
        end
        //  ̑
        else
        begin
            Err := 'א̃oXłB';
            Exit;
        end;
    end;

    //-------------------------------------------
    //  STEP5

    //  (9)ɋ؂Ă

    //  ̃o[R[ȟ킷Buf̃TCYύX
    SetLength(CharBuf, CharLen);

    for i := 0 to CharLen - 1 do
    begin
        Temp := 10 * i;
        CharBuf[i] := SumBuf[Temp + 0] * 256
                    + SumBuf[Temp + 1] * 128
                    + SumBuf[Temp + 2] * 64
                    + SumBuf[Temp + 3] * 32
                    + SumBuf[Temp + 4] * 16
                    + SumBuf[Temp + 5] * 8
                    + SumBuf[Temp + 6] * 4
                    + SumBuf[Temp + 7] * 2
                    + SumBuf[Temp + 8] * 1;
        //SumBuf[Temp + 9] LN^ԃMbv
    end;

    //-------------------------------------------
    //  STEP6

    //  o
    Text := '';
    for i := 0 to CharLen - 1 do
    begin
        case CharBuf[i] of
        289: Text := Text + '1';
         97: Text := Text + '2';
        352: Text := Text + '3';
         49: Text := Text + '4';
        304: Text := Text + '5';
        112: Text := Text + '6';
         37: Text := Text + '7';
        292: Text := Text + '8';
        100: Text := Text + '9';
         52: Text := Text + '0';
        265: Text := Text + 'A';
         73: Text := Text + 'B';
        328: Text := Text + 'C';
         25: Text := Text + 'D';
        280: Text := Text + 'E';
         88: Text := Text + 'F';
         13: Text := Text + 'G';
        268: Text := Text + 'H';
         76: Text := Text + 'I';
         28: Text := Text + 'J';
        259: Text := Text + 'K';
         67: Text := Text + 'L';
        322: Text := Text + 'M';
         19: Text := Text + 'N';
        274: Text := Text + 'O';
         82: Text := Text + 'P';
          7: Text := Text + 'Q';
        262: Text := Text + 'R';
         70: Text := Text + 'S';
         22: Text := Text + 'T';
        385: Text := Text + 'U';
        193: Text := Text + 'V';
        448: Text := Text + 'W';
        145: Text := Text + 'X';
        400: Text := Text + 'Y';
        208: Text := Text + 'Z';
        133: Text := Text + '-';
        388: Text := Text + '.';
        196: Text := Text + ' ';
        148: Text := Text + '*';
        168: Text := Text + '$';
        162: Text := Text + '/';
        138: Text := Text + '+';
         42: Text := Text + '%';
        else Text := Text + '?';
        end;
    end;

    //-------------------------------------------
    //  STEP7

    //  X^[gR[hEXgbvR[h`FbN
    if (Text[1] <> '*') then
    begin
        Err := 'X^[gR[h*ł͂܂B' + Text;
        Exit;
    end
    else if (Text[Length(Text)] <> '*') then
    begin
        Err := 'XgbvR[h*ł͂܂B' + Text;
        Exit;
    end;

    //  X^[gR[hEXgbvR[h
    Delete(Text, 1, 1);
    Delete(Text, Length(Text), 1);

    Result := True;
end;

end.
